<?php

namespace Eater\Glim\Model\Base;

use \Exception;
use \PDO;
use Eater\Glim\Model\Certificate as ChildCertificate;
use Eater\Glim\Model\CertificateQuery as ChildCertificateQuery;
use Eater\Glim\Model\Map\CertificateTableMap;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveQuery\ModelJoin;
use Propel\Runtime\Collection\ObjectCollection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\PropelException;

/**
 * Base class that represents a query for the 'Certificate' table.
 *
 *
 *
 * @method     ChildCertificateQuery orderById($order = Criteria::ASC) Order by the id column
 * @method     ChildCertificateQuery orderByUserId($order = Criteria::ASC) Order by the user_id column
 * @method     ChildCertificateQuery orderByName($order = Criteria::ASC) Order by the name column
 * @method     ChildCertificateQuery orderByCertificate($order = Criteria::ASC) Order by the certificate column
 * @method     ChildCertificateQuery orderByPrivateKey($order = Criteria::ASC) Order by the private_key column
 * @method     ChildCertificateQuery orderByExpiresOn($order = Criteria::ASC) Order by the expires_on column
 * @method     ChildCertificateQuery orderByRevoked($order = Criteria::ASC) Order by the revoked column
 * @method     ChildCertificateQuery orderBySerial($order = Criteria::ASC) Order by the serial column
 *
 * @method     ChildCertificateQuery groupById() Group by the id column
 * @method     ChildCertificateQuery groupByUserId() Group by the user_id column
 * @method     ChildCertificateQuery groupByName() Group by the name column
 * @method     ChildCertificateQuery groupByCertificate() Group by the certificate column
 * @method     ChildCertificateQuery groupByPrivateKey() Group by the private_key column
 * @method     ChildCertificateQuery groupByExpiresOn() Group by the expires_on column
 * @method     ChildCertificateQuery groupByRevoked() Group by the revoked column
 * @method     ChildCertificateQuery groupBySerial() Group by the serial column
 *
 * @method     ChildCertificateQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     ChildCertificateQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     ChildCertificateQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     ChildCertificateQuery leftJoinUser($relationAlias = null) Adds a LEFT JOIN clause to the query using the User relation
 * @method     ChildCertificateQuery rightJoinUser($relationAlias = null) Adds a RIGHT JOIN clause to the query using the User relation
 * @method     ChildCertificateQuery innerJoinUser($relationAlias = null) Adds a INNER JOIN clause to the query using the User relation
 *
 * @method     \Eater\Glim\Model\UserQuery endUse() Finalizes a secondary criteria and merges it with its primary Criteria
 *
 * @method     ChildCertificate findOne(ConnectionInterface $con = null) Return the first ChildCertificate matching the query
 * @method     ChildCertificate findOneOrCreate(ConnectionInterface $con = null) Return the first ChildCertificate matching the query, or a new ChildCertificate object populated from the query conditions when no match is found
 *
 * @method     ChildCertificate findOneById(int $id) Return the first ChildCertificate filtered by the id column
 * @method     ChildCertificate findOneByUserId(int $user_id) Return the first ChildCertificate filtered by the user_id column
 * @method     ChildCertificate findOneByName(string $name) Return the first ChildCertificate filtered by the name column
 * @method     ChildCertificate findOneByCertificate(string $certificate) Return the first ChildCertificate filtered by the certificate column
 * @method     ChildCertificate findOneByPrivateKey(string $private_key) Return the first ChildCertificate filtered by the private_key column
 * @method     ChildCertificate findOneByExpiresOn(string $expires_on) Return the first ChildCertificate filtered by the expires_on column
 * @method     ChildCertificate findOneByRevoked(boolean $revoked) Return the first ChildCertificate filtered by the revoked column
 * @method     ChildCertificate findOneBySerial(string $serial) Return the first ChildCertificate filtered by the serial column *

 * @method     ChildCertificate requirePk($key, ConnectionInterface $con = null) Return the ChildCertificate by primary key and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildCertificate requireOne(ConnectionInterface $con = null) Return the first ChildCertificate matching the query and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 *
 * @method     ChildCertificate requireOneById(int $id) Return the first ChildCertificate filtered by the id column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildCertificate requireOneByUserId(int $user_id) Return the first ChildCertificate filtered by the user_id column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildCertificate requireOneByName(string $name) Return the first ChildCertificate filtered by the name column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildCertificate requireOneByCertificate(string $certificate) Return the first ChildCertificate filtered by the certificate column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildCertificate requireOneByPrivateKey(string $private_key) Return the first ChildCertificate filtered by the private_key column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildCertificate requireOneByExpiresOn(string $expires_on) Return the first ChildCertificate filtered by the expires_on column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildCertificate requireOneByRevoked(boolean $revoked) Return the first ChildCertificate filtered by the revoked column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildCertificate requireOneBySerial(string $serial) Return the first ChildCertificate filtered by the serial column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 *
 * @method     ChildCertificate[]|ObjectCollection find(ConnectionInterface $con = null) Return ChildCertificate objects based on current ModelCriteria
 * @method     ChildCertificate[]|ObjectCollection findById(int $id) Return ChildCertificate objects filtered by the id column
 * @method     ChildCertificate[]|ObjectCollection findByUserId(int $user_id) Return ChildCertificate objects filtered by the user_id column
 * @method     ChildCertificate[]|ObjectCollection findByName(string $name) Return ChildCertificate objects filtered by the name column
 * @method     ChildCertificate[]|ObjectCollection findByCertificate(string $certificate) Return ChildCertificate objects filtered by the certificate column
 * @method     ChildCertificate[]|ObjectCollection findByPrivateKey(string $private_key) Return ChildCertificate objects filtered by the private_key column
 * @method     ChildCertificate[]|ObjectCollection findByExpiresOn(string $expires_on) Return ChildCertificate objects filtered by the expires_on column
 * @method     ChildCertificate[]|ObjectCollection findByRevoked(boolean $revoked) Return ChildCertificate objects filtered by the revoked column
 * @method     ChildCertificate[]|ObjectCollection findBySerial(string $serial) Return ChildCertificate objects filtered by the serial column
 * @method     ChildCertificate[]|\Propel\Runtime\Util\PropelModelPager paginate($page = 1, $maxPerPage = 10, ConnectionInterface $con = null) Issue a SELECT query based on the current ModelCriteria and uses a page and a maximum number of results per page to compute an offset and a limit
 *
 */
abstract class CertificateQuery extends ModelCriteria
{
    protected $entityNotFoundExceptionClass = '\\Propel\\Runtime\\Exception\\EntityNotFoundException';

    /**
     * Initializes internal state of \Eater\Glim\Model\Base\CertificateQuery object.
     *
     * @param     string $dbName The database name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = 'default', $modelName = '\\Eater\\Glim\\Model\\Certificate', $modelAlias = null)
    {
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new ChildCertificateQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param     Criteria $criteria Optional Criteria to build the query from
     *
     * @return ChildCertificateQuery
     */
    public static function create($modelAlias = null, Criteria $criteria = null)
    {
        if ($criteria instanceof ChildCertificateQuery) {
            return $criteria;
        }
        $query = new ChildCertificateQuery();
        if (null !== $modelAlias) {
            $query->setModelAlias($modelAlias);
        }
        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param ConnectionInterface $con an optional connection object
     *
     * @return ChildCertificate|array|mixed the result, formatted by the current formatter
     */
    public function findPk($key, ConnectionInterface $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = CertificateTableMap::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(CertificateTableMap::DATABASE_NAME);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @throws \Propel\Runtime\Exception\PropelException
     *
     * @return ChildCertificate A model object, or null if the key is not found
     */
    protected function findPkSimple($key, ConnectionInterface $con)
    {
        $sql = 'SELECT id, user_id, name, certificate, private_key, expires_on, revoked, serial FROM Certificate WHERE id = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), 0, $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(\PDO::FETCH_NUM)) {
            /** @var ChildCertificate $obj */
            $obj = new ChildCertificate();
            $obj->hydrate($row);
            CertificateTableMap::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @return ChildCertificate|array|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, ConnectionInterface $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($dataFetcher);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     ConnectionInterface $con an optional connection object
     *
     * @return ObjectCollection|array|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getReadConnection($this->getDbName());
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($dataFetcher);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return $this|ChildCertificateQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(CertificateTableMap::COL_ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return $this|ChildCertificateQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(CertificateTableMap::COL_ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id > 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildCertificateQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(CertificateTableMap::COL_ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(CertificateTableMap::COL_ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(CertificateTableMap::COL_ID, $id, $comparison);
    }

    /**
     * Filter the query on the user_id column
     *
     * Example usage:
     * <code>
     * $query->filterByUserId(1234); // WHERE user_id = 1234
     * $query->filterByUserId(array(12, 34)); // WHERE user_id IN (12, 34)
     * $query->filterByUserId(array('min' => 12)); // WHERE user_id > 12
     * </code>
     *
     * @see       filterByUser()
     *
     * @param     mixed $userId The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildCertificateQuery The current query, for fluid interface
     */
    public function filterByUserId($userId = null, $comparison = null)
    {
        if (is_array($userId)) {
            $useMinMax = false;
            if (isset($userId['min'])) {
                $this->addUsingAlias(CertificateTableMap::COL_USER_ID, $userId['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($userId['max'])) {
                $this->addUsingAlias(CertificateTableMap::COL_USER_ID, $userId['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(CertificateTableMap::COL_USER_ID, $userId, $comparison);
    }

    /**
     * Filter the query on the name column
     *
     * Example usage:
     * <code>
     * $query->filterByName('fooValue');   // WHERE name = 'fooValue'
     * $query->filterByName('%fooValue%'); // WHERE name LIKE '%fooValue%'
     * </code>
     *
     * @param     string $name The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildCertificateQuery The current query, for fluid interface
     */
    public function filterByName($name = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($name)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $name)) {
                $name = str_replace('*', '%', $name);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(CertificateTableMap::COL_NAME, $name, $comparison);
    }

    /**
     * Filter the query on the certificate column
     *
     * Example usage:
     * <code>
     * $query->filterByCertificate('fooValue');   // WHERE certificate = 'fooValue'
     * $query->filterByCertificate('%fooValue%'); // WHERE certificate LIKE '%fooValue%'
     * </code>
     *
     * @param     string $certificate The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildCertificateQuery The current query, for fluid interface
     */
    public function filterByCertificate($certificate = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($certificate)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $certificate)) {
                $certificate = str_replace('*', '%', $certificate);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(CertificateTableMap::COL_CERTIFICATE, $certificate, $comparison);
    }

    /**
     * Filter the query on the private_key column
     *
     * Example usage:
     * <code>
     * $query->filterByPrivateKey('fooValue');   // WHERE private_key = 'fooValue'
     * $query->filterByPrivateKey('%fooValue%'); // WHERE private_key LIKE '%fooValue%'
     * </code>
     *
     * @param     string $privateKey The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildCertificateQuery The current query, for fluid interface
     */
    public function filterByPrivateKey($privateKey = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($privateKey)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $privateKey)) {
                $privateKey = str_replace('*', '%', $privateKey);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(CertificateTableMap::COL_PRIVATE_KEY, $privateKey, $comparison);
    }

    /**
     * Filter the query on the expires_on column
     *
     * Example usage:
     * <code>
     * $query->filterByExpiresOn('2011-03-14'); // WHERE expires_on = '2011-03-14'
     * $query->filterByExpiresOn('now'); // WHERE expires_on = '2011-03-14'
     * $query->filterByExpiresOn(array('max' => 'yesterday')); // WHERE expires_on > '2011-03-13'
     * </code>
     *
     * @param     mixed $expiresOn The value to use as filter.
     *              Values can be integers (unix timestamps), DateTime objects, or strings.
     *              Empty strings are treated as NULL.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildCertificateQuery The current query, for fluid interface
     */
    public function filterByExpiresOn($expiresOn = null, $comparison = null)
    {
        if (is_array($expiresOn)) {
            $useMinMax = false;
            if (isset($expiresOn['min'])) {
                $this->addUsingAlias(CertificateTableMap::COL_EXPIRES_ON, $expiresOn['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($expiresOn['max'])) {
                $this->addUsingAlias(CertificateTableMap::COL_EXPIRES_ON, $expiresOn['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(CertificateTableMap::COL_EXPIRES_ON, $expiresOn, $comparison);
    }

    /**
     * Filter the query on the revoked column
     *
     * Example usage:
     * <code>
     * $query->filterByRevoked(true); // WHERE revoked = true
     * $query->filterByRevoked('yes'); // WHERE revoked = true
     * </code>
     *
     * @param     boolean|string $revoked The value to use as filter.
     *              Non-boolean arguments are converted using the following rules:
     *                * 1, '1', 'true',  'on',  and 'yes' are converted to boolean true
     *                * 0, '0', 'false', 'off', and 'no'  are converted to boolean false
     *              Check on string values is case insensitive (so 'FaLsE' is seen as 'false').
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildCertificateQuery The current query, for fluid interface
     */
    public function filterByRevoked($revoked = null, $comparison = null)
    {
        if (is_string($revoked)) {
            $revoked = in_array(strtolower($revoked), array('false', 'off', '-', 'no', 'n', '0', '')) ? false : true;
        }

        return $this->addUsingAlias(CertificateTableMap::COL_REVOKED, $revoked, $comparison);
    }

    /**
     * Filter the query on the serial column
     *
     * Example usage:
     * <code>
     * $query->filterBySerial('fooValue');   // WHERE serial = 'fooValue'
     * $query->filterBySerial('%fooValue%'); // WHERE serial LIKE '%fooValue%'
     * </code>
     *
     * @param     string $serial The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildCertificateQuery The current query, for fluid interface
     */
    public function filterBySerial($serial = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($serial)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $serial)) {
                $serial = str_replace('*', '%', $serial);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(CertificateTableMap::COL_SERIAL, $serial, $comparison);
    }

    /**
     * Filter the query by a related \Eater\Glim\Model\User object
     *
     * @param \Eater\Glim\Model\User|ObjectCollection $user The related object(s) to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @throws \Propel\Runtime\Exception\PropelException
     *
     * @return ChildCertificateQuery The current query, for fluid interface
     */
    public function filterByUser($user, $comparison = null)
    {
        if ($user instanceof \Eater\Glim\Model\User) {
            return $this
                ->addUsingAlias(CertificateTableMap::COL_USER_ID, $user->getId(), $comparison);
        } elseif ($user instanceof ObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(CertificateTableMap::COL_USER_ID, $user->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByUser() only accepts arguments of type \Eater\Glim\Model\User or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the User relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this|ChildCertificateQuery The current query, for fluid interface
     */
    public function joinUser($relationAlias = null, $joinType = Criteria::LEFT_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('User');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'User');
        }

        return $this;
    }

    /**
     * Use the User relation User object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return \Eater\Glim\Model\UserQuery A secondary query class using the current class as primary query
     */
    public function useUserQuery($relationAlias = null, $joinType = Criteria::LEFT_JOIN)
    {
        return $this
            ->joinUser($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'User', '\Eater\Glim\Model\UserQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   ChildCertificate $certificate Object to remove from the list of results
     *
     * @return $this|ChildCertificateQuery The current query, for fluid interface
     */
    public function prune($certificate = null)
    {
        if ($certificate) {
            $this->addUsingAlias(CertificateTableMap::COL_ID, $certificate->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

    /**
     * Deletes all rows from the Certificate table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public function doDeleteAll(ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(CertificateTableMap::DATABASE_NAME);
        }

        // use transaction because $criteria could contain info
        // for more than one table or we could emulating ON DELETE CASCADE, etc.
        return $con->transaction(function () use ($con) {
            $affectedRows = 0; // initialize var to track total num of affected rows
            $affectedRows += parent::doDeleteAll($con);
            // Because this db requires some delete cascade/set null emulation, we have to
            // clear the cached instance *after* the emulation has happened (since
            // instances get re-added by the select statement contained therein).
            CertificateTableMap::clearInstancePool();
            CertificateTableMap::clearRelatedInstancePool();

            return $affectedRows;
        });
    }

    /**
     * Performs a DELETE on the database based on the current ModelCriteria
     *
     * @param ConnectionInterface $con the connection to use
     * @return int             The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                         if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public function delete(ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(CertificateTableMap::DATABASE_NAME);
        }

        $criteria = $this;

        // Set the correct dbName
        $criteria->setDbName(CertificateTableMap::DATABASE_NAME);

        // use transaction because $criteria could contain info
        // for more than one table or we could emulating ON DELETE CASCADE, etc.
        return $con->transaction(function () use ($con, $criteria) {
            $affectedRows = 0; // initialize var to track total num of affected rows

            CertificateTableMap::removeInstanceFromPool($criteria);

            $affectedRows += ModelCriteria::delete($con);
            CertificateTableMap::clearRelatedInstancePool();

            return $affectedRows;
        });
    }

} // CertificateQuery
